#include "level_history.h"
#include <stdlib.h>
#include <string.h>

LevelHistory::~LevelHistory() {
	if(e) free(e);
}

size_t LevelHistory::makeEdge(unsigned time) {
	size_t l=0;
	size_t h=es;
	while(l<h) {
		size_t s=(l+h)/2;
		unsigned t = e[s].time;
		if(t<time)
			l = s+1;
		else if(t>time)
			h = s;
		else
			return s;
	}
	//insert edge at <l>
	if(es==e_allocated) {
		//realloc
		if(e_allocated==0)
			e_allocated = 32;
		else
			e_allocated *= 2;
		e = (Edge*)realloc(e, sizeof(Edge)*e_allocated);
	}
	memmove(e+l+1, e+l, sizeof(Edge)*(es-l));
	es++;
	e[l].time = time;
	if(l>0)
		e[l].level = e[l-1].level;
	else
		e[l].level = 0;
	return l;
}


void LevelHistory::increment(unsigned from_time, unsigned to_time) {
	size_t from_idx = makeEdge(from_time);
	size_t to_idx = makeEdge(to_time);
	
	for(size_t i=from_idx; i<to_idx; i++)
		e[i].level++;
}
