#include "analyze_output.h"
#include "level_history.h"
#include "preanalyze.h"

void stat_object_use(const EventRecord ev[], size_t events,
                     Object *o_obj, size_t objs,
		     const char *objname, const char *objsname)
{
	char section_name[256];
	sprintf(section_name,"%s histogram",objname);
	OutputSectionStart(section_name);
	LevelHistory lh;
	for(size_t i=0; i<objs; i++) {
		unsigned from_idx;
		if(o_obj[i].create_event)
			from_idx = (unsigned)(o_obj[i].create_event-ev);
		else
			from_idx = 0;
		unsigned to_idx;
		if(o_obj[i].destroy_event)
			to_idx = (unsigned)(o_obj[i].destroy_event-ev);
		else
			to_idx = (unsigned)events;
		lh.increment(from_idx,to_idx);
	}
	
	fprintf(fp_output,"Time              #%s\n",objsname);
	for(size_t i=0; i<lh.edges(); i++) {
		unsigned ev_idx = lh.edgeTime(i);
		unsigned level = lh.edgeLevel(i);
		if(ev_idx<events)
			fprintf(fp_output,"%17.6f %u\n", ev[ev_idx].timestamp, level);
		else
			fprintf(fp_output,"%17.6f %u\n", ev[events-1].timestamp+0.000001, level);
	}
	OutputSectionEnd(section_name);
}
