#include <pthread.h>

static pthread_mutex_t mtx = PTHREAD_MUTEX_INITIALIZER;
static pthread_cond_t cond = PTHREAD_COND_INITIALIZER;

static void *thread_func(void *pv) {
	pthread_mutex_lock(&mtx);
	pthread_cond_signal(&cond);
	pthread_mutex_unlock(&mtx);
	return pv;
}

int main(void) {
	pthread_t tid;
	
	pthread_mutex_lock(&mtx);
	
	pthread_create(&tid,0,thread_func,0);
	
	pthread_cond_wait(&cond,&mtx);
	pthread_mutex_unlock(&mtx);
	
	pthread_mutex_destroy(&mtx);
	
	return 0;
}
